<h1>Positioning: Float</h1>

<p><em>Float</em> property positions an element far right or left within its container, other elements will move up and
flow around the element. You can also use 'inherit' or 'none' values.</p>
<p>Here the image has the property 'float: left' of its container, the text flows around it.</p>

<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .image {{'{'}}
    float: left;
    margin: 5px;
  }
</pre>
</div>
<br>
<div class="floatContainer">
  <img class="image1" src="../../assets/images/leaves.jpg" alt="Leaves">
  <p>"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.
    Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.
    Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur... "</p>
</div>

<br>
<h1>Overflow: Auto</h1>
<p>We can also make the image float right. Notice here that the image is taller in height than the text, which makes it overspill its container.
  We can fix this by assigning the container the 'overflow: auto' property. </p>
<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .container {{'{'}}
    overflow: auto;
    border: 1px solid white;
  }
</pre>
</div>
<br>


<div class="fakeContainer">
  <img class="image2" src="../../assets/images/leaves.jpg" alt="Leaves">
  <p>"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua."</p>
</div>
<em>Without overflow: auto</em>
<div class="spacer"></div>

<div class="floatContainer">
  <img class="image2" src="../../assets/images/leaves.jpg" alt="Leaves">
  <p>"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua."</p>
</div>
<em>With overflow: auto</em>

<div class="spacer"></div>

<h1>Grid Layouts</h1>
<p>You can even use float to create a grid-like format. Here we have given the property 'float: left' to each image and also
given it a width of '25%', this means the width is split equally into 4 sections across the width of the container.</p>

<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .images {{'{'}}
    float: left;
    width: 25%;
    padding: 20px;
  }
</pre>
</div>

<img class="image3" src="../../assets/images/spring.jpg" alt="spring"/>
<img class="image3" src="../../assets/images/summer.jpg" alt="summer"/>
<img class="image3" src="../../assets/images/leaves.jpg" alt="autumn"/>
<img class="image3" src="../../assets/images/winter.jpg" alt="winter"/>


<br>

<h1>Clear Property</h1>

<p>The 'clear' property specifies whether another element can float next to it. For example if we do not want text to flow around
an image that has a float property. You can use the values 'right' or 'left' to ensure there are not floating items on either left or right.
Or if you want to  clear both sides then you can use 'both'.</p>

<div class="col-md-4 codeExample">
  <em>styles.css</em>
  <pre>
  .images {{'{'}}
    float: right;
  }
  .text {{'{'}}
    clear: both;
  }
</pre>
</div>
<br>
<div class="floatContainer">
  <img class="image2" src="../../assets/images/leaves.jpg" alt="Leaves">
  <p class="text">"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua."</p>
</div>
